#ifndef OBJECT_H
#define OBJECT_H

#include <OS.h>		// for types such as uint32

#include "LnList.h"

class Creature;

class Object
{
	public:
		Object( const char * );
		virtual ~Object();
				
		virtual void Use( Creature * target, Creature * source = NULL);
		
		uint32		id;
		
		const char	* name;
		uint32		bitmap;
		
		uint32		equip; // equipment mask, Creature::HEAD and so on

		const char	* skill; // skill used to activate object
};

class ObjectSet
{
	public:
		ObjectSet();
		~ObjectSet();
		
		void		Add( Object * );
		Object *	Find( uint32 );

	protected:
		uint32			next_id;
		List<Object>	objects;
};


#endif
