#include "basic_objects.h"

#include "Creature.h"
#include <stdio.h>


// BLOODY MESS

BloodyMess::BloodyMess()
:	Object( "a bloody mess" )
{
}

BloodyMess::~BloodyMess()
{
}

BloodyMessInfo::BloodyMessInfo()
{
	bmp[0].file = "/add-ons/gfx/bloody_mess/bloody_mess";
	bmp[1].file = NULL;
	bitmaps = bmp;
	name = "bloody mess";
}

Object *
BloodyMessInfo::Create( Dungeon * )
{
	BloodyMess * mess = new BloodyMess;
	mess->bitmap = bmp[0].id;

	return mess;
}

bool
BloodyMessInfo::ShouldPlace( int level )
{
	return false;
}

// HEALTH POTION

HealthPotion::HealthPotion()
:	Object("a health potion")
{
	used = false;
}

HealthPotion::~HealthPotion()
{
}

void
HealthPotion::Use( Creature * target, Creature * )
{
	if (used)
		return;
	
	int gain = random() % 10+5;
	target->HP.curr += gain;
	if (target->HP.curr > target->HP.base)
		target->HP.curr = target->HP.base;
	
	char text[256];
	sprintf(text, "*clunk* *clunk* - %s gains %d hitpoints", target->name, gain );
	game_message( target->pos, text, be_bold_font, (rgb_color){128,128,255,255} );
	
	used = true;
	bitmap = empty_id;
}

HealthPotionInfo::HealthPotionInfo()
{
	bmp[0].file = "/add-ons/gfx/blue_potion/blue_potion";
	bmp[1].file = "/add-ons/gfx/empty_potion/empty_potion";
	bmp[2].file = NULL;
	bitmaps = bmp;

	name = "health potion";
}

Object *
HealthPotionInfo::Create( Dungeon * )
{
	HealthPotion * potion = new HealthPotion;
	potion->bitmap = bmp[0].id;
	potion->empty_id = bmp[1].id;

	return potion;
}

// Sword

Sword::Sword()
:	Object("a sword")
{
	skill = "1H Sword";
	equip = Creature::RIGHT_HAND;
}

Sword::~Sword()
{
}

void
Sword::Use( Creature * target, Creature * source )
{
	if (!source)
	{
		game_message( Pos(-1,-1), "Invalid source argument to Sword::Use()" );
		return;
	}
	
	damage dmg;
	dmg.amount = random() % 5 + source->STR.curr;
	dmg.source = source;
	dmg.type = damage::SLASH;
	
	char text[512];
	sprintf(text,"%s slashes %s for %d dmg",source->name,target->name,dmg.amount);
	game_message( Pos(-1,-1), text, be_bold_font, (rgb_color){255,0,0,255} );
	target->Damage( dmg );
	
}

SwordInfo::SwordInfo()
{
	bmp[0].file = "/add-ons/gfx/sword/sword";
	bmp[1].file = NULL;
	bitmaps = bmp;

	name = "sword";
}

Object *
SwordInfo::Create( Dungeon * )
{
	Sword * sword = new Sword;
	sword->bitmap = bmp[0].id;

	return sword;
}

bool
SwordInfo::ShouldPlace( int level )
{
	if ( (random() % 5) == 0 )
		return true; // only place a sword 20% of given opportunities
	return false;
}

// BUILDER

BasicObjectBuilder::BasicObjectBuilder()
:	ObjectBuilder( "BasicObjectBuilder" )
{
	info_original[0] = &health_info;
	info_original[1] = &mess_info;
	info_original[2] = &sword_info;
	info_original[3] = NULL;
	info = info_original;

	text = "BasicObjectBuilder";
}

// EXPORT

ObjectBuilder * 
CreateObjectBuilder()
{
	return new BasicObjectBuilder;
}

